# IBM XL C/C++ for Linux


Overview
--------

IBM XL C/C++ for Linux, V13.1.3 is an advanced, high-performance compiler that can be used for developing complex,
computationally intensive programs, including inter-language calls with C and Fortran programs.

Information on the fully functional IBM XL C/C++ trial version for an evaluation period of 60 days is
available at: [Trial Download] [trial-xlc].

To get more details about the product and useful additional resources, please visit
the [Product Page] [product-page] and [IBM Knowledge Center] [ibm-xlc-info].

**Note: This charm is specifically designed to run on Power architecture (ppc64le) systems only. It will not run on
AMD (amd64) or Intel (x86_64) based systems. Use `uname -m` to determine the architecture of your cloud instances.**

For more information on Supported OS for IBM XL C/C++ please visit: [OS Support] [os-hardware-support].


Usage
-----
The charm is for IBM XL C/C++ for Linux V13.1.3, Evaluation version. This software
is goverened by 2 license files:

  * IBM International License Agreement for Evaluation of Programs
    - PDF included in this charm at `./files/license-eval.pdf`
  * IBM XL C/C++ for Linux V13.1.3, Evaluation License Information
    - PDF included in this charm at `./files/license.pdf`

**Note: Deploying this charm signifies your acceptance of the terms in the above 2 license files. If you
do not accept these terms, do not deploy this charm**.


Deploy
------
IBM XLC is a subordinate charm that can be related to a service which requires a C/C++ development environment.
To deploy the IBM XLC charm, follow the below steps:

    juju deploy ibm-xlc

At this point, IBM XLC is waiting for a relationship to some other service. It can be any service or some specific service which requires
C/C++ as this charm relates via the juju-info and xlc-compiler interfaces.

To test the deployment of this charm, you can deploy IBM XL C/C++ on the `ubuntu` unit as shown below:

    juju deploy ubuntu
    juju add-relation ubuntu ibm-xlc


This charm will deploy the IBM XL C/C++ compiler packages. It will also enable the manual pages and compiler error messages.
Manual pages are provided for the compiler invocation commands and other utilities that are supplied with the compiler.

The charm will also create sample `C` and `C++` programs placed in the `./files/archives` path. User can compile and run these sample programs
for testing purpose.


#### Installing IBM-XLC charm with new trial version of IBM XL C/C++

To install the IBM XL C/C++ charm when a new evaluation version is available, follow the below steps:

1) Remove your existing IBM XLC service

    juju destroy-service ibm-xlc

2) Deploy the charm again (Refer to the Deploy section above)


Configuration
-------------
None


IBM XL C/C++ Information
----------------------------
(1) General Information

Information on IBM XL C/C++ available at the [IBM Knowledge Center] [ibm-xlc-info].

(2) Download Information

Information on downloading the fully functional trial for an evaluation period of 60 days is available at [Trial Download] [trial-xlc].

(3) Contact Information

For issues with this charm, please contact IBM Juju Support Team <jujusupp@us.ibm.com>.

(4) Known Limitations

This charm makes use of Juju Status commands, and requires `juju 1.24` or greater

<!-- Links -->

[product-page]: http://www-03.ibm.com/software/products/en/ccompfami

[trial-xlc]: http://www.ibm.com/developerworks/downloads/r/xlcpluslinux/

[ibm-xlc-info]: http://www-01.ibm.com/support/knowledgecenter/SSXVZZ_13.1.3/com.ibm.compilers.linux.doc/welcome.html

[os-hardware-support]: http://www-01.ibm.com/support/knowledgecenter/SSXVZZ_13.1.3/com.ibm.xlcpp1313.lelinux.doc/getstart/ossup.html?lang=en
